package com.ruoyi.service.client;


import java.security.SecureRandom;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import java.util.concurrent.TimeUnit;
import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.KeyManager;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;

import com.ruoyi.service.client.HttpConfig;
import okhttp3.ConnectionPool;
import okhttp3.OkHttpClient;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class HttpClient {
    private static final Logger LOG = LoggerFactory.getLogger(com.ruoyi.service.client.HttpClient.class);
    private static com.ruoyi.service.client.HttpClient httpClient = null;
    private OkHttpClient okHttpClient;

    private HttpClient() {
        this.initOkHttpClient();
    }

    public static com.ruoyi.service.client.HttpClient getInstance() {
        if (null == httpClient) {
            Class var0 = com.ruoyi.service.client.HttpClient.class;
            synchronized(com.ruoyi.service.client.HttpClient.class) {
                if (null == httpClient) {
                    httpClient = new com.ruoyi.service.client.HttpClient();
                }
            }
        }

        return httpClient;
    }

    public OkHttpClient getClient() {
        return this.okHttpClient;
    }

    private void initOkHttpClient() {
        this.okHttpClient = this.okHttpClient();
    }

    private OkHttpClient okHttpClient() {
        return (new OkHttpClient.Builder()).sslSocketFactory(this.sslSocketFactory(), this.x509TrustManager()).hostnameVerifier(new HostnameVerifier() {
            public boolean verify(String s, SSLSession sslSession) {
                return true;
            }
        }).retryOnConnectionFailure(false).connectionPool(this.pool()).connectTimeout((long) HttpConfig.connectTimeoutSeconds(), TimeUnit.SECONDS).readTimeout((long)HttpConfig.readTimeoutSeconds(), TimeUnit.SECONDS).writeTimeout((long)HttpConfig.writeTimeoutSeconds(), TimeUnit.SECONDS).build();
    }

    private X509TrustManager x509TrustManager() {
        return new X509TrustManager() {
            public void checkClientTrusted(X509Certificate[] x509Certificates, String s) throws CertificateException {
            }

            public void checkServerTrusted(X509Certificate[] x509Certificates, String s) throws CertificateException {
            }

            public X509Certificate[] getAcceptedIssuers() {
                return new X509Certificate[0];
            }
        };
    }

    private SSLSocketFactory sslSocketFactory() {
        try {
            SSLContext sslContext = SSLContext.getInstance("TLS");
            sslContext.init((KeyManager[])null, new TrustManager[]{this.x509TrustManager()}, new SecureRandom());
            return sslContext.getSocketFactory();
        } catch (Exception var2) {
            Exception e = var2;
            LOG.error("create ssl socket factory failed", e);
            return null;
        }
    }

    private ConnectionPool pool() {
        return new ConnectionPool(HttpConfig.maxConnections(), (long)HttpConfig.connKeepaliveMinute(), TimeUnit.MINUTES);
    }
}

