package com.ruoyi.service.domain;


import com.ruoyi.service.domain.ServiceRequestFieldDTO;
import com.ruoyi.service.utils.Tools;
import java.util.ArrayList;
import java.util.List;

public class DataQuery {
    private List<ServiceRequestFieldDTO> must;
    private List<ServiceRequestFieldDTO> should;

    public DataQuery() {
    }

    public DataQuery(List<ServiceRequestFieldDTO> must, List<ServiceRequestFieldDTO> should) {
        this.must = must;
        this.should = should;
    }

    public com.ruoyi.service.domain.DataQuery must(ServiceRequestFieldDTO field) {
        if (Tools.isNull(this.must)) {
            this.must = new ArrayList();
        }

        this.must.add(field);
        return this;
    }

    public com.ruoyi.service.domain.DataQuery should(ServiceRequestFieldDTO field) {
        if (Tools.isNull(this.should)) {
            this.should = new ArrayList();
        }

        this.should.add(field);
        return this;
    }

    public List<ServiceRequestFieldDTO> getMust() {
        return this.must;
    }

    public List<ServiceRequestFieldDTO> getShould() {
        return this.should;
    }

    public static class Builder {
        private List<ServiceRequestFieldDTO> must;
        private List<ServiceRequestFieldDTO> should;

        public Builder() {
        }

        public com.ruoyi.service.domain.DataQuery.Builder must(ServiceRequestFieldDTO field) {
            if (Tools.isNull(this.must)) {
                this.must = new ArrayList();
            }

            this.must.add(field);
            return this;
        }

        public com.ruoyi.service.domain.DataQuery.Builder should(ServiceRequestFieldDTO field) {
            if (Tools.isNull(this.should)) {
                this.should = new ArrayList();
            }

            this.should.add(field);
            return this;
        }

        public com.ruoyi.service.domain.DataQuery.Builder must(List<ServiceRequestFieldDTO> fields) {
            if (Tools.isNull(this.must)) {
                this.must = new ArrayList();
            }

            this.must.addAll(fields);
            return this;
        }

        public com.ruoyi.service.domain.DataQuery.Builder should(List<ServiceRequestFieldDTO> fields) {
            if (Tools.isNull(this.should)) {
                this.should = new ArrayList();
            }

            this.should.addAll(fields);
            return this;
        }

        public com.ruoyi.service.domain.DataQuery build() {
            return new com.ruoyi.service.domain.DataQuery(this.must, this.should);
        }
    }
}

