package com.ruoyi.service.utils;


import com.ruoyi.service.constants.SignatureMethod;
import com.ruoyi.service.constants.SignatureVersion;
import com.ruoyi.service.domain.AuthInfo;
import java.security.SignatureException;
import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;

import com.ruoyi.service.utils.Tools;
import org.apache.commons.codec.binary.Base64;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class IdentifyTools {
    private static final Logger log = LoggerFactory.getLogger(com.ruoyi.service.utils.IdentifyTools.class);
    private static final Logger logger = LoggerFactory.getLogger(com.ruoyi.service.utils.IdentifyTools.class);

    public IdentifyTools() {
    }

    public static boolean auth(AuthInfo auth, String params, String solt, String signature) {
        try {
            if (Tools.isNull(auth.getSignatureVersion())) {
                return false;
            } else {
                String signatureMethod = (SignatureVersion.VERSION2.getCode().equals(auth.getSignatureVersion()) ? SignatureMethod.HmacSHA256 : SignatureMethod.HmacSHA1).getCode();
                String signStr = sign(params, solt, signatureMethod, auth.getEncoding());
                return signature.equals(signStr);
            }
        } catch (Exception var6) {
            Exception e = var6;
            logger.error("认证错误:", e);
            return false;
        }
    }

    public static String sign(String data, String key, String signatureMethod, String encoding) throws SignatureException {
        byte[] signature;
        try {
            Mac mac = Mac.getInstance(signatureMethod);
            mac.init(new SecretKeySpec(key.getBytes(), signatureMethod));
            signature = Base64.encodeBase64(mac.doFinal(data.getBytes(encoding)));
        } catch (Exception var6) {
            Exception e = var6;
            throw new SignatureException("生成签名失败:" + e.getMessage(), e);
        }

        return new String(signature);
    }
}

